{CON

    _clkmode        = xtal1 + pll16x
    _xinfreq        = 5_000_000                 }


{{'WheelSpeed' ramp methods added
 V2 use global variables which initialize to zero
 Does not work properly }}

OBJ 
             pst     : "Parallax Serial Terminal" 
                                                           
VAR

  long  stack[60], NumberOfSteps,TotalTime,ComputedTime,T,OneTenthTime,RSteps,RComputedTime,StepAddUp,TimeAddUp
  byte  cog,x,y,idx

PUB main

    pst.Start(115_200)
    waitcnt(clkfreq * 2 + cnt)        
    
    Start_B(x, y)
                    
PUB Start_B(a, b)  | L, R        
                                               
      L := b
      R := a    
 
      Stop                                                      
  '    cognew(Raymans_StyleLS(L), @stack[1])
     cognew(Raymans_StyleLS(1018), @stack[1])
  '    Stop                                                      
   '   cognew(Raymans_StyleLS(R), @stack[1])
      cognew(Raymans_StyleRS(742), @stack[30])
                                                                                
PUB stop

    If cog 
      cogstop(cog)  

PUB Raymans_StyleLS(L) | i 

    dira[8..11]~~                                'basic calculations
    NumberOfSteps :=  L '2018                    'running speed
    TotalTime := clkfreq * 2                     'time allowed for ramping
    ComputedTime := TotalTime / NumberOfSteps    'cramming more steps into the same amount of time speeds up
    T := cnt                                     'ramping calculations
    OneTenthTime := TotalTime / 10               'divide time into ten segments
    RSteps := StepAddUp := L / 100               'divide total number of steps by 100
  '  RComputedTime := OneTenthTime/RSteps         '0.1 / 0.01 = 10  this is evaluated only once
  
 {   repeat idx from 1 to 10      
      RSteps := StepAddUp * idx                  '600/100 * idx
      TimeAddUp :=  OneTenthTime/RSteps   'RComputedTime/RSteps          ' this line causes a problemS   

 {     pst.Chars(pst#NL, 2)
      pst.Dec(RSteps)           ' increments by 6
      pst.Chars(pst#NL, 1)  
      pst.Dec(TimeAddUp)         'decrements                         
      waitcnt(clkfreq / 2 + cnt)                   }
      
      repeat RSteps
        T += TimeAddUp     'RComputedTime
        NewStepLS(i++)
        waitcnt(T)                                                 }
    '    waitcnt(clkfreq / 2 + cnt)
   '     pst.Chars(pst#NL, 1)  
    '    pst.Dec(RComputedTime)         'decrements  
    '                                        
                                      
    repeat NumberOfSteps
      T += ComputedTime             'ComputedTime = 1066666                
      NewStepLS(i++) 
      waitcnt(T)
 '     pst.Chars(pst#NL, 2)
  '    pst.Dec(ComputedTime)                     

PUB Raymans_StyleRS(R) | i 

    dira[15..12]~~                                'basic calculations
    NumberOfSteps :=  R '2018                    'running speed
    TotalTime := clkfreq * 2                     'time allowed for ramping
    ComputedTime := TotalTime / NumberOfSteps    'cramming more steps into the same amount of time speeds up
    T := cnt                                     'ramping calculations
    OneTenthTime := TotalTime / 10               'divide time into ten segments
    RSteps := StepAddUp := R / 100               'divide total number of steps by 100
 '   RComputedTime := OneTenthTime/RSteps         '0.1 / 0.01 = 10  this is evaluated only once
  
{    repeat idx from 1 to 10      
      RSteps := StepAddUp * idx                  '600/100 * idx
      TimeAddUp :=  OneTenthTime/RSteps   'RComputedTime/RSteps          ' this line causes a problemS      
      
      repeat RSteps
        T += TimeAddUp     'RComputedTime
        NewStepRS(i++)
        waitcnt(T)                                              
                                                                      }
    repeat NumberOfSteps
      T += ComputedTime             'ComputedTime = 1066666                
      NewStepRS(i++) 
      waitcnt(T)
 '     pst.Chars(pst#NL, 2)
'      pst.Dec(ComputedTime)                                            
                                      
PRI NewStepLS(n)
  n := n // 4
  case n
    0:
      outa[8..11]:=%1100
    1:
      outa[8..11]:=%0110   
    2:
      outa[8..11]:=%0011   
    3:
      outa[8..11]:=%1001                                        

PRI NewStepRS(n)
  n := n // 4
  case n
    0:
      outa[15..12]:=%1100
    1:
      outa[15..12]:=%0110   
    2:
      outa[15..12]:=%0011   
    3:
      outa[15..12]:=%1001                                        
 